#!/usr/bin/env python2

import re
import sys

DELTA_RE = re.compile(r"\(\+(\d{2,3})\)")


def group_by_occurence_count(lines):
    line_to_count = {}
    for line in lines:
        count = line_to_count.setdefault(line, 0)
        line_to_count[line] = count + 1
    count_to_lines = {}
    for line, count in line_to_count.items():
        line_list = count_to_lines.setdefault(count, [])
        line_list.append(line)
    return count_to_lines


def split_by_rss_delta(lines):
    deltas = set()
    current_lines = []
    for line in lines:
        match = DELTA_RE.search(line)
        if match:
            delta = int(match.groups()[0])
            if not delta in deltas:
                deltas.add(delta)
                with open(str(delta), "w") as delta_file:
                    occurence_count = group_by_occurence_count(current_lines)
                    sorted_counts = reversed(sorted(list(occurence_count)))
                    for count in sorted_counts:
                        lines = occurence_count[count]
                        for line in lines:
                            delta_file.write("{:>4} x {}".format(count, line))
            current_lines = []
        else:
            line = line[35:]
            current_lines.append(line)


if __name__ == '__main__':
    log_file_path = sys.argv[1]
    with open(log_file_path) as log_file:
        split_by_rss_delta(log_file.readlines())
